require('config')

button_option = {}

function button_option:new(name, on_press)
  local o = setmetatable({}, { __index = self })

  o.name = name
  o.on_press = on_press

  return o
end

function button_option:get_height()
  return config.button.height
end

function button_option:render(pos, group_width, padding)
  local rect_color = config.button.bg
  local text_center_x = pos.x + (group_width * 0.5)
  local text_center_y = pos.y + (config.button.height * 0.5)

  if input.is_mouse_in_bounds(pos, vec2(group_width, config.button.height)) then
    if input.mouse(1).just_pressed then
      self.on_press()
    end
    rect_color = config.button.hover_bg
  end

  gui.rect(pos, vec2(group_width, config.button.height))
    :rounding(config.button.rounding)
    :color(rect_color)
    :draw()

  gui.text(self.name)
    :position(vec2(text_center_x, text_center_y - (config.button.scale * 0.5)))
    :color(config.button.text)
    :override_scale(config.button.scale)
    :justify(Justify.CENTER)
    :draw()

  return config.button.height
end