require('scrollbar')

Column = {
  LEFT = 1,
  RIGHT = 2
}

options = {
  player = {
    root = {},
    invincible = {},
    never_wanted = {}
  },

  settings = {
    root = {}
  }
}

config = {
  -- button_option
  button = {
    height = 24.0,
    rounding = 4.0,
    scale = 17.0,
    text = color(255, 255, 255),
    bg = color(50, 50, 50),
    hover_bg = color(45, 45, 45),
  },

  -- number_option
  number = {
    bar_height = 8.0,
    bar_spacing = 4.0,
    bar_rounding = 4.0,
    scale = 17.0,
    text = color(255, 255, 255),
    bar = color(50, 50, 50),
    bar_value = color(80, 80, 80),
  },

  -- toggle_option
  toggle = {
    height = 18.0,
    rounding = 4.0,
    scale = 17.0,
    left_size = true,
    left_size_padding = 8.0,
    text = color(255, 255, 255),
    bg = color(50, 50, 50),
    hover_bg = color(45, 45, 45),
    enabled_bg = color(138, 4, 69),
  },

  -- group_option
  group = {
    scale = 18.0,
    rounding = 4.0,
    spacing = 4.0,
    banner_height = 10.0,
    banner_flags = Rounding.TOP_LEFT | Rounding.TOP_RIGHT,
    bg_flags = Rounding.BOTTOM_LEFT | Rounding.BOTTOM_RIGHT,
    text = color(138, 4, 69),
    bg = color(25, 25, 25),
    banner_ul = color(138, 4, 69),
    banner_ur = color(28, 1, 13),
    banner_bl = color(138, 4, 69),
    banner_br = color(28, 1, 13),
  },

  -- Main UI
  main = {
    position = vec2(500.0, 100.0),
    scale = vec2(700.0, 500.0),
    bg_rounding = 4.0,
    bg_thickness = 1.0,
    scrollbar_rounding = 8.0,
    scrollbar_width = 8.0,
    sub_tab_seperator = 180.0,
    sub_tab_rounding = 4.0,
    sub_tab_text_padding = 5.0,
    sub_tab_title_text_scale = 18.0,
    sub_tab_text_scale = 16.0,
    selected_tab_bar_scale = vec2(2.0, 10.0),
    selected_sub_tab_bar_scale = vec2(2.0, 10.0),
    tab_rounding = 4.0,
    tab_line_thickness = 1.0,
    sub_tab_thickness = 1.0,
    tab_seperator = 45.0,
    tab_item_padding = 6.0,
    tab_icon_size = 16.0,
    tab_icon_box_size = 30.0,
    scrollbar_bg = color(0, 0, 0, 50),
    scrollbar_bar = color(69, 8, 36),
    bg = color(20, 20, 20),
    bg_outline = color(255, 255, 255, 30),
    tab_line = color(255, 255, 255, 30),
    sub_tab = color(255, 255, 255, 30),
    sub_tab_title_text = color(200, 200, 200, 200),
    sub_tab_title_icon = color(138, 4, 69),
    tab_bg = color(25, 25, 25),
    tab_icon = color(50, 50, 50),
    selected_tab_bar = color(69, 8, 36),
    selected_tab_bg = color(69, 8, 36),
    selected_tab_icon = color(138, 4, 69),
    sub_tab_title_bg = color(69, 8, 36),
    selected_sub_tab_bar = color(69, 8, 36),
    sub_tab_bg = color(25, 25, 25),
    sub_tab_text = color(50, 50, 50),
    selected_sub_tab_bg = color(40, 40, 40),
    selected_sub_tab_text = color(200, 200, 200, 200),
  },

  open_key = 0x2D, -- Insert
  is_open = true,
  selected_tab = 1,
  selected_sub_tab = 1,
  tab_scrollbar = scrollbar:new(nil),

  tabs = {
    { '', 'Player' },
    { '', 'Network' },
    { '', 'Spawner' },
    { '', 'Teleport' },
    { '', 'Weapon' },
    { '', 'Vehicle' },
    { '', 'World' },
    { '', 'Misc' },
    { '', 'Settings' },
  },

  sub_tabs = {
    {
      {
        'Root',
        options.player.root
      },
      {
        'Model',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.player.root
      }
    },
    {
      {
        'Root',
        options.settings.root
      }
    },
  },
}