require('util')

toggle_option = {}

function toggle_option:new(name)
  local o = setmetatable({}, { __index = self })

  o.name = name
  o.toggle = false

  return o
end

function toggle_option:get_height()
  return utils.max(config.toggle.height, config.toggle.scale)
end

function toggle_option:render(pos, group_width, padding)
  local toggle_scale = vec2(self:get_height())
  local toggle_pos = vec2(pos.x + group_width - toggle_scale.y, pos.y)
  local text_pos = vec2(pos.x, pos.y + (toggle_scale.y * 0.5) - (config.toggle.scale * 0.5))
  local box_color = config.toggle.bg

  if config.toggle.left_size then
    toggle_pos = pos
    text_pos.x = pos.x + toggle_scale.x + config.toggle.left_size_padding
  end
  
  if input.is_mouse_in_bounds(toggle_pos, toggle_scale) or input.is_mouse_in_bounds(text_pos, gui.get_size(self.name, config.toggle.scale)) then
    if input.mouse(1).just_pressed then
      self.toggle = not self.toggle
    end
    
    if not self.toggle then
      box_color = config.toggle.hover_bg
    end
  end

  gui.text(self.name)
    :position(text_pos)
    :color(config.toggle.text)
    :override_scale(config.toggle.scale)
    :draw()

  if self.toggle then
    box_color = config.toggle.enabled_bg
  end

  gui.rect(toggle_pos, toggle_scale)
    :rounding(config.toggle.rounding)
    :color(box_color)
    :draw()

  return toggle_scale.y
end